Package com.ngrok.services

# Class SshCertificateAuthorities.CreateCallBuilder

java.lang.Object
com.ngrok.services.SshCertificateAuthorities.CreateCallBuilder

Enclosing class:
  SshCertificateAuthorities

public class SshCertificateAuthorities.CreateCallBuilder extends Object
A builder object encapsulating state for an unsent Create API call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SshCertificateAuthority`
  `blockingCall()`
  Initiates the API call and blocks until it returns.
  `CompletionStage<SshCertificateAuthority>`
  `call()`
  Initiates the API call asynchronously.
  `SshCertificateAuthorities.CreateCallBuilder`
  `description(String description)`
  human-readable description of this SSH Certificate Authority.
  `SshCertificateAuthorities.CreateCallBuilder`
  `description(Optional<String> description)`
  human-readable description of this SSH Certificate Authority.
  `SshCertificateAuthorities.CreateCallBuilder`
  `ellipticCurve(String ellipticCurve)`
  the type of elliptic curve to use when creating an ECDSA key
  `SshCertificateAuthorities.CreateCallBuilder`
  `ellipticCurve(Optional<String> ellipticCurve)`
  the type of elliptic curve to use when creating an ECDSA key
  `SshCertificateAuthorities.CreateCallBuilder`
  `keySize(long keySize)`
  the key size to use when creating an RSA key.
  `SshCertificateAuthorities.CreateCallBuilder`
  `keySize(Optional<Long> keySize)`
  the key size to use when creating an RSA key.
  `SshCertificateAuthorities.CreateCallBuilder`
  `metadata(String metadata)`
  arbitrary user-defined machine-readable data of this SSH Certificate Authority.
  `SshCertificateAuthorities.CreateCallBuilder`
  `metadata(Optional<String> metadata)`
  arbitrary user-defined machine-readable data of this SSH Certificate Authority.
  `SshCertificateAuthorities.CreateCallBuilder`
  `privateKeyType(String privateKeyType)`
  the type of private key to generate.
  `SshCertificateAuthorities.CreateCallBuilder`
  `privateKeyType(Optional<String> privateKeyType)`
  the type of private key to generate.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### description

    public SshCertificateAuthorities.CreateCallBuilder description(String description)
    human-readable description of this SSH Certificate Authority. optional, max 255 bytes.
    Parameters:
      `description` - the value of the description parameter as a `String`
    Returns:
      the call builder instance

  - ### description

    public SshCertificateAuthorities.CreateCallBuilder description(Optional<String> description)
    human-readable description of this SSH Certificate Authority. optional, max 255 bytes.
    Parameters:
      `description` - the value of the description parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### metadata

    public SshCertificateAuthorities.CreateCallBuilder metadata(String metadata)
    arbitrary user-defined machine-readable data of this SSH Certificate Authority. optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as a `String`
    Returns:
      the call builder instance

  - ### metadata

    public SshCertificateAuthorities.CreateCallBuilder metadata(Optional<String> metadata)
    arbitrary user-defined machine-readable data of this SSH Certificate Authority. optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### privateKeyType

    public SshCertificateAuthorities.CreateCallBuilder privateKeyType(String privateKeyType)
    the type of private key to generate. one of `rsa`, `ecdsa`, `ed25519`
    Parameters:
      `privateKeyType` - the value of the private_key_type parameter as a `String`
    Returns:
      the call builder instance

  - ### privateKeyType

    public SshCertificateAuthorities.CreateCallBuilder privateKeyType(Optional<String> privateKeyType)
    the type of private key to generate. one of `rsa`, `ecdsa`, `ed25519`
    Parameters:
      `privateKeyType` - the value of the private_key_type parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### ellipticCurve

    public SshCertificateAuthorities.CreateCallBuilder ellipticCurve(String ellipticCurve)
    the type of elliptic curve to use when creating an ECDSA key
    Parameters:
      `ellipticCurve` - the value of the elliptic_curve parameter as a `String`
    Returns:
      the call builder instance

  - ### ellipticCurve

    public SshCertificateAuthorities.CreateCallBuilder ellipticCurve(Optional<String> ellipticCurve)
    the type of elliptic curve to use when creating an ECDSA key
    Parameters:
      `ellipticCurve` - the value of the elliptic_curve parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### keySize

    public SshCertificateAuthorities.CreateCallBuilder keySize(long keySize)
    the key size to use when creating an RSA key. one of `2048` or `4096`
    Parameters:
      `keySize` - the value of the key_size parameter as a `long`
    Returns:
      the call builder instance

  - ### keySize

    public SshCertificateAuthorities.CreateCallBuilder keySize(Optional<Long> keySize)
    the key size to use when creating an RSA key. one of `2048` or `4096`
    Parameters:
      `keySize` - the value of the key_size parameter as an `Optional` of `long`
    Returns:
      the call builder instance

  - ### call

    public CompletionStage<SshCertificateAuthority> call()
    Initiates the API call asynchronously.
    Returns:
      a `CompletionStage` of `SshCertificateAuthority`

  - ### blockingCall

    public SshCertificateAuthority blockingCall() throws InterruptedException
    Initiates the API call and blocks until it returns.
    Returns:
      `SshCertificateAuthority`
    Throws:
      `InterruptedException` - if the thread was interrupted during the call